// DynamDOM.cpp : Defines the entry point for the console application.
//
#include <stdio.h>
#include <tchar.h>
#include <msxml6.h>


#pragma once
class XMLLibWrapper
{
public:
	XMLLibWrapper(void);
	~XMLLibWrapper(void);

	//-----------------------------------------

	bool XMLLibWrapper::CreateEnvDataDoc();

	bool XMLLibWrapper::WriteEnvDataEntry( PCWSTR Name, PCWSTR Value );

	bool XMLLibWrapper::WriteEnvDataEntry_Sysitem( PCWSTR Name, PCWSTR Value );

	bool XMLLibWrapper::SaveEnvDataDoc( PCWSTR Filename);

	//-----------------------------------------
	
	bool CreateAFileEventsDoc();

	bool WriteFileEvent( PCWSTR procid, PCWSTR process, PCWSTR datetime, PCWSTR operation, PCWSTR Filepath, PCWSTR Filepath2 );

	bool SaveFileEventsDoc( PCWSTR Filename );

	bool WriteFileDataLostError();

	//-----------------------------------------

	bool CreateARegEventsDoc();

	bool WriteRegEvent( PCWSTR procid, PCWSTR process, PCWSTR datetime, PCWSTR operation, PCWSTR Regpath, PCWSTR ValueName, PCWSTR DataType, PCWSTR Data );

	bool SaveRegEventsDoc( PCWSTR Filename );

	bool WriteRegDataLostError();

private:

	IXMLDOMDocument			*pXMLEnvDataDom;
	IXMLDOMElement			*pEnvContextRoot;
	IXMLDOMElement			*pEnvItemsRoot;
 

	IXMLDOMDocument			*pXMLFileEventsDom;
	IXMLDOMElement			*pFileCaptureRoot;
    IXMLDOMElement			*pFileEventsRoot;

	IXMLDOMDocument			*pXMLRegEventsDom;
	IXMLDOMElement			*pRegCaptureRoot;
    IXMLDOMElement			*pRegEventsRoot;

	HRESULT VariantFromString(PCWSTR wszValue, VARIANT &Variant);

	HRESULT CreateAndInitDOM(IXMLDOMDocument **ppDoc);

	HRESULT CreateElement(IXMLDOMDocument *pXMLDom, PCWSTR wszName, IXMLDOMElement **ppElement);

	HRESULT AppendChildToParent(IXMLDOMNode *pChild, IXMLDOMNode *pParent);

	HRESULT CreateAndAddPINode(IXMLDOMDocument *pDom, PCWSTR wszTarget, PCWSTR wszData);

	HRESULT CreateAndAddCommentNode(IXMLDOMDocument *pDom, PCWSTR wszComment);

	HRESULT CreateAndAddAttributeNode(IXMLDOMDocument *pDom, PCWSTR wszName, PCWSTR wszValue, IXMLDOMElement *pParent);

	HRESULT CreateAndAddTextNode(IXMLDOMDocument *pDom, PCWSTR wszText, IXMLDOMNode *pParent);

	HRESULT CreateAndAddCDATANode(IXMLDOMDocument *pDom, PCWSTR wszCDATA, IXMLDOMNode *pParent);

	HRESULT CreateAndAddElementNode(IXMLDOMDocument *pDom, PCWSTR wszName, PCWSTR wszNewline, IXMLDOMNode *pParent, IXMLDOMElement **ppElement );

};

