//---------------------------------------------------
//
// RegFilterInterfaceDefs.h
//
// Defs of types and stuctures used for communication
// between user mode and the Registry Filter Driver
//
//---------------------------------------------------

#include "Ntsecapi.h"


//---------------------------------------------------
//
// This is a struture that is used to fill a buffer
// with Registry Events

#pragma warning( push )

#pragma warning ( disable : 4200 )		// compiler whinges about empty array in struct.


typedef struct  _REG_EVENT_RECORD 
{
	REG_NOTIFY_CLASS	eventType;
	LARGE_INTEGER		time;			// changed type of field.
	UCHAR				dataLost;		// new field
	DWORD				processId;
	ULONG				dataType;
	ULONG				dataLengthB;
	ULONG				registryPathLengthB;
	ULONG				registryPathKeyLengthB;				/* added 9/6/2011: ML : length of the key part of the full regpath (bytes) */
	UCHAR				registryData[];
} REG_EVENT_RECORD, * PREG_EVENT_RECORD;


#pragma warning( pop )

// IO event code used to request for a buffer of Registry Events

#define IOCTL_GET_REGISTRY_EVENTS			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x803, METHOD_NEITHER,FILE_READ_DATA | FILE_WRITE_DATA)




//-----------------------------------------------------------------------------------
